Не подмодуль a git подмодуль

Как я могу подмодулировать подмодуль git (вернуть весь код в ядро)?

Как в том, как "должен" я, как в "Лучшей процедуре"...

+260
источник поделиться
11 ответов

Если все, что вам нужно, это поместить ваш код подмодуля в основной репозиторий, вам просто нужно удалить подмодуль и повторно добавить файлы в основное репо:

git rm --cached submodule_path # delete reference to submodule HEAD (no trailing slash)
git rm .gitmodules             # if you have more than one submodules,
                               # you need to edit this file instead of deleting!
rm -rf submodule_path/.git     # make sure you have backup!!
git add submodule_path         # will add files instead of commit reference
git commit -m "remove submodule"

Если вы также хотите сохранить историю подмодуля, вы можете сделать небольшой трюк: "объединить" подмодуль в основной репозиторий, чтобы результат был таким же, как и раньше, за исключением того, что файлы подмодуля теперь в основном репозитории.

В основном модуле вам нужно будет сделать следующее:

# Fetch the submodule commits into the main repository
git remote add submodule_origin git://url/to/submodule/origin
git fetch submodule_origin

# Start a fake merge (won't change any files, won't commit anything)
git merge -s ours --no-commit submodule_origin/master

# Do the same as in the first solution
git rm --cached submodule_path # delete reference to submodule HEAD
git rm .gitmodules             # if you have more than one submodules,
                               # you need to edit this file instead of deleting!
rm -rf submodule_path/.git     # make sure you have backup!!
git add submodule_path         # will add files instead of commit reference

# Commit and cleanup
git commit -m "removed submodule"
git remote rm submodule_origin

Результирующий репозиторий будет выглядеть немного странным: будет более одного начального коммита. Но это не вызовет проблем для git.

В этом втором решении у вас будет большое преимущество в том, что вы все равно можете запустить git вину или git log на файлы, которые первоначально были в подмодулях. Фактически, вы сделали это, чтобы переименовать много файлов внутри одного репозитория, а git должен автоопределить это. Если у вас все еще есть проблемы с журналом git, попробуйте некоторые параметры (--follow, -M, -C), которые лучше переименовывают/копируют обнаружение.

+400
источник

Так как git 1.8.5 (ноябрь 2013 г.)) (без сохранения подмодуля):

mv yoursubmodule yoursubmodule_tmp
git submodule deinit yourSubmodule
git rm yourSubmodule
mv yoursubmodule_tmp yoursubmodule
git add yoursubmodule

Это будет:

  • unregister и выгрузить (т.е. удалить содержимое) подмодуль (deinit, а значит, mv),
  • очистите .gitmodules для вас (rm),
  • и удалите специальную запись, представляющую этот подмодуль SHA1 в индексе родительского репо (rm).

Как только удаление субмодуля завершено (deinit и git rm), вы можете переименовать папку обратно в исходное имя и добавить ее в репозиторий git как обычную папку.

Примечание: если подмодуль был создан старым git (< 1.8), вам может потребоваться удалить вложенную папку .git внутри самого подмодуля, поскольку прокомментировал Саймон Ист


Если вам нужно сохранить историю подмодуля, см. jsears , который использует git filter-branch.

+51
источник
другие ответы

Связанные вопросы


Похожие вопросы

С нами случилось, что мы создали 2 репозитория для двух проектов, которые были настолько связаны, что не имело никакого смысла их разделять, поэтому мы объединили их.

Я покажу, как объединить главные ветки в каждом первом, а затем я объясню, как вы можете распространить это на все ветки, которые у вас есть, надеюсь, что это поможет вам.

Если вы получили подмодуль, и вы хотите преобразовать его в каталог, который вы можете сделать:

git clone project_uri project_name

Здесь мы делаем чистый клон для работы. Для этого процесса вам не нужно инициализировать или обновлять подмодули, поэтому просто пропустите его.

cd project_name
vim .gitmodules

Измените .gitmodules своим любимым редактором (или Vim), чтобы удалить подмодуль, который вы планируете заменить. Строки, которые нужно удалить, должны выглядеть примерно так:

[submodule "lib/asi-http-request"]
    path = lib/asi-http-request
    url = https://github.com/pokeb/asi-http-request.git

После сохранения файла

git rm --cached directory_of_submodule
git commit -am "Removed submodule_name as submodule"
rm -rf directory_of_submodule

Здесь мы полностью снимаем отношение подмодуля, чтобы мы могли создать другое репо для проекта на месте.

git remote add -f submodule_origin submodule_uri
git fetch submodel_origin/master

Здесь мы получаем репозиторий подмодулей для объединения.

git merge -s ours --no-commit submodule_origin/master

Здесь мы начинаем операцию слияния двух репозиториев, но останавливаемся перед фиксацией.

git read-tree --prefix=directory_of_submodule/ -u submodule_origin/master

Здесь мы отправляем содержимое мастера в подмодуле в каталог, где он был до префикса имени каталога

git commit -am "submodule_name is now part of main project"

Здесь мы завершаем процедуру, выполняющую фиксацию изменений в слиянии.

После этого вы можете нажать и начать снова с любой другой ветки, чтобы объединиться, просто проверьте ветку в вашем репозитории, которая получит изменения и изменит ветвь, которую вы ввели в операции слияния и чтения.

+13
источник

Я создал script, который преобразует подмодуль в простой каталог, сохраняя при этом всю историю файлов. Он не страдает от проблем git log --follow <file>, от которых страдают другие решения. Это также очень простой однострочный вызов, который делает всю работу за вас. G'luck.

Он основывается на превосходной работе Lucas Jenß, описанной в его блоге " Интеграция подмодуля в родительский репозиторий", но автоматизирует весь процесс и очищает несколько других угловых случаев.

Последний код будет поддерживаться с исправлениями на github в https://github.com/jeremysears/scripts/blob/master/bin/git-submodule-rewrite, но для правильного протокола ответа stackoverflow я включало решение в целом ниже.

Использование:

$ git-submodule-rewrite <submodule-name>

git подмодуль-переписывают:

#!/usr/bin/env bash

# This script builds on the excellent work by Lucas Jenß, described in his blog
# post "Integrating a submodule into the parent repository", but automates the
# entire process and cleans up a few other corner cases.
# https://x3ro.de/2013/09/01/Integrating-a-submodule-into-the-parent-repository.html

function usage(){
  echo "Merge a submodule into a repo, retaining file history."
  echo "Usage: $0 <submodule-name>"
  echo ""
  echo "options:"
  echo "  -h, --help                Print this message"
  echo "  -v, --verbose             Display verbose output"
}

function abort {
    echo "$(tput setaf 1)$1$(tput sgr0)"
    exit 1
}

function request_confirmation {
    read -p "$(tput setaf 4)$1 (y/n) $(tput sgr0)"
    [ "$REPLY" == "y" ] || abort "Aborted!"
}

function warn() {
  cat << EOF
    This script will convert your "${sub}" git submodule into
    a simple subdirectory in the parent repository while retaining all
    contents and file history.

    The script will:
      * delete the ${sub} submodule configuration from .gitmodules and
        .git/config and commit it.
      * rewrite the entire history of the ${sub} submodule so that all
        paths are prefixed by ${path}.
        This ensures that git log will correctly follow the original file
        history.
      * merge the submodule into its parent repository and commit it.

    NOTE: This script might completely garble your repository, so PLEASE apply
    this only to a fresh clone of the repository where it does not matter if
    the repo is destroyed.  It would be wise to keep a backup clone of your
    repository, so that you can reconstitute it if need be.  You have been
    warned.  Use at your own risk.

EOF

  request_confirmation "Do you want to proceed?"
}

function git_version_lte() {
  OP_VERSION=$(printf "%03d%03d%03d%03d" $(echo "$1" | tr '.' '\n' | head -n 4))
  GIT_VERSION=$(git version)
  GIT_VERSION=$(printf "%03d%03d%03d%03d" $(echo "${GIT_VERSION#git version}" | tr '.' '\n' | head -n 4))
  echo -e "${GIT_VERSION}\n${OP_VERSION}" | sort | head -n1
  [ ${OP_VERSION} -le ${GIT_VERSION} ]
}

function main() {

  warn

  if [ "${verbose}" == "true" ]; then
    set -x
  fi

  # Remove submodule and commit
  git config -f .gitmodules --remove-section "submodule.${sub}"
  if git config -f .git/config --get "submodule.${sub}.url"; then
    git config -f .git/config --remove-section "submodule.${sub}"
  fi
  rm -rf "${path}"
  git add -A .
  git commit -m "Remove submodule ${sub}"
  rm -rf ".git/modules/${sub}"

  # Rewrite submodule history
  local tmpdir="$(mktemp -d -t submodule-rewrite-XXXXXX)"
  git clone "${url}" "${tmpdir}"
  pushd "${tmpdir}"
  local tab="$(printf '\t')"
  local filter="git ls-files -s | sed \"s/${tab}/${tab}${path}\//\" | GIT_INDEX_FILE=\${GIT_INDEX_FILE}.new git update-index --index-info && mv \${GIT_INDEX_FILE}.new \${GIT_INDEX_FILE}"
  git filter-branch --index-filter "${filter}" HEAD
  popd

  # Merge in rewritten submodule history
  git remote add "${sub}" "${tmpdir}"
  git fetch "${sub}"

  if git_version_lte 2.8.4
  then
    # Previous to git 2.9.0 the parameter would yield an error
    ALLOW_UNRELATED_HISTORIES=""
  else
    # From git 2.9.0 this parameter is required
    ALLOW_UNRELATED_HISTORIES="--allow-unrelated-histories"
  fi

  git merge -s ours --no-commit ${ALLOW_UNRELATED_HISTORIES} "${sub}/master"
  rm -rf tmpdir

  # Add submodule content
  git clone "${url}" "${path}"
  rm -rf "${path}/.git"
  git add "${path}"
  git commit -m "Merge submodule contents for ${sub}"
  git config -f .git/config --remove-section "remote.${sub}"

  set +x
  echo "$(tput setaf 2)Submodule merge complete. Push changes after review.$(tput sgr0)"
}

set -euo pipefail

declare verbose=false
while [ $# -gt 0 ]; do
    case "$1" in
        (-h|--help)
            usage
            exit 0
            ;;
        (-v|--verbose)
            verbose=true
            ;;
        (*)
            break
            ;;
    esac
    shift
done

declare sub="${1:-}"

if [ -z "${sub}" ]; then
  >&2 echo "Error: No submodule specified"
  usage
  exit 1
fi

shift

if [ -n "${1:-}" ]; then
  >&2 echo "Error: Unknown option: ${1:-}"
  usage
  exit 1
fi

if ! [ -d ".git" ]; then
  >&2 echo "Error: No git repository found.  Must be run from the root of a git repository"
  usage
  exit 1
fi

declare path="$(git config -f .gitmodules --get "submodule.${sub}.path")"
declare url="$(git config -f .gitmodules --get "submodule.${sub}.url")"

if [ -z "${path}" ]; then
  >&2 echo "Error: Submodule not found: ${sub}"
  usage
  exit 1
fi

if ! [ -d "${path}" ]; then
  >&2 echo "Error: Submodule path not found: ${path}"
  usage
  exit 1
fi

main
+11
источник
  • git rm --cached the_submodule_path
  • удалите раздел подмодуля из файла .submodules
  • выполнить фиксацию "удаленный подмодуль xyz"
  • git add the_submodule_path
  • другая фиксация "добавлена ​​кодовая база xyz"

Я еще не нашел более легкого пути. Вы можете сжать 3-5 в один шаг через git commit -a - дело вкуса.

+10
источник

Здесь много ответов, но все они кажутся чрезмерно сложными и, вероятно, не делают того, что вы хотите. Я уверен, что большинство людей хотят сохранить свою историю.

В этом примере основное репо будет git@site.com:main/main.git, а репозитория подмодуля будет git@site.com:main/child.git. Это предполагает, что подмодуль находится в корневой директории родительского репо. При необходимости отрегулируйте инструкции.

Начните с клонирования родительского репо и удаления старого подмодуля.

git clone git@site.com:main/main.git
git submodule deinit child
git rm child
git add --all
git commit -m "remove child submodule"

Теперь мы добавим дочерние репозитории вверх по течению к основному репо.

git remote add upstream git@site.com:main/child.git
git fetch upstream
git checkout -b merge-prep upstream/master

Следующий шаг предполагает, что вы хотите переместить файлы в ветки слияния в том же месте, что и подмодуль, хотя вы можете легко изменить местоположение, изменив путь к файлу.

mkdir child

переместите все папки и файлы, кроме папки .git, в дочернюю папку.

git add --all
git commit -m "merge prep"

Теперь вы можете просто объединить свои файлы обратно в главную ветвь.

git checkout master
git merge merge-prep # --allow-unrelated-histories merge-prep flag may be required 

Осмотритесь и убедитесь, что все хорошо выглядит перед запуском git push

Теперь вам нужно помнить, что журнал git по умолчанию не отслеживает перемещенные файлы, однако, запустив git log --follow filename, вы можете увидеть полную историю ваших файлов.

+10
источник

Лучший ответ на это я нашел здесь:

http://x3ro.de/2013/09/01/Integrating-a-submodule-into-the-parent-repository.html

В этой статье очень хорошо объясняется процедура.

+6
источник

Если

git rm [-r] --cached submodule_path

возвращает

fatal: pathspec 'emr/normalizers/' did not match any files

Контекст: я сделал rm -r .git* в своих папках подмодулей, прежде чем понял, что им нужно было де-подмодулировать в основном проекте, к которому я только что добавил. Я получил вышеупомянутую ошибку, когда де-подмодулировать некоторые, но не все из них. Во всяком случае, я исправил их, запустив (после, конечно, rm -r .git*)

mv submodule_path submodule_path.temp
git add -A .
git commit -m "De-submodulization phase 1/2"
mv submodule_path.temp submodule_path
git add -A .
git commit -m "De-submodulization phase 2/2"

Обратите внимание, что это не сохраняет историю.

+3
источник

Здесь немного улучшенная версия (IMHO) текущего верхнего ответа:

В отдельном каталоге (чтобы сделать ошибки проще для очистки и повторить попытку) проверьте как верхнее репо, так и подрепорт.

git clone ../main_repo main.tmp
git clone ../main_repo/sub_repo sub.tmp

Сначала отредактируйте subrepo, чтобы переместить все файлы в нужный подкаталог

cd sub.tmp
mkdir sub_repo_path
git mv `ls | grep -v sub_repo_path` sub_repo_path/
git commit -m "Moved entire subrepo into sub_repo_path"

Запишите HEAD

SUBREPO_HEAD=`git reflog | awk '{ print $1; exit; }'`

Теперь удалите subrepo из основного репо

cd ../main.tmp
rmdir sub_repo_path
vi .gitmodules  # remove config for submodule
git add -A
git commit -m "Removed submodule sub_repo_path in preparation for merge"

И, наконец, просто слейте их

git fetch ../sub.tmp
git merge $SUBREPO_HEAD

И сделано! Безопасно и без магии.

+3
источник

На основе VonC answer, я создал простой bash script, который делает это. add в конце должен использовать подстановочные знаки, иначе он отменит предыдущий rm для самого подмодуля. Важно добавить содержимое каталога подмодулей, а не указывать сам каталог в команде add.

В файле с именем git-integrate-submodule:

#!/usr/bin/env bash
mv "$1" "${1}_"
git submodule deinit "$1"
git rm "$1"
mv "${1}_" "$1"
git add "$1/**"
+2
источник

Мне было удобнее (также?) извлекать локальные данные фиксации из подмодуля, потому что в противном случае я бы потерял их. (Не удалось нажать их, поскольку у меня нет доступа к этому пульту). Таким образом, я добавил subodule/.git как remote_origin2, получил его, и он слился с этой ветвью. Не уверен, что мне все еще нужен пульт subodule как источник, так как я еще недостаточно знаком с git.

0
источник

Посмотрите другие вопросы по меткам или Задайте вопрос